<?php

namespace IMATHUZH\Qfq\Core\Exception;

class Thrower
{
    /**
     * Throws UserFormException with given messages to user and developer.
     *
     * @param string $errorToUser
     * @param string $errorToDeveloper
     * @param int $errorCode
     * @throws \UserFormException
     */
    public static function userFormException(string $errorToUser, string $errorToDeveloper = '', int $errorCode = E_ERROR) {
        throw new \UserFormException(json_encode([
            ERROR_MESSAGE_TO_USER => $errorToUser,
            ERROR_MESSAGE_TO_DEVELOPER => $errorToDeveloper]), $errorCode);
    }

    /**
     * Throws UserReportException with given messages to user and developer.
     *
     * @param string $errorToUser
     * @param string $errorToDeveloper
     * @param int $errorCode
     * @throws \UserReportException
     */
    public static function userReportException(string $errorToUser, string $errorToDeveloper = '', int $errorCode = E_ERROR) {
        throw new \UserReportException(json_encode([
            ERROR_MESSAGE_TO_USER => $errorToUser,
            ERROR_MESSAGE_TO_DEVELOPER => $errorToDeveloper]), $errorCode);
    }
}